<?php

use SangoBlocks\App;

function sng_space_css($block, $id) {
  $spaceBottom = isset($block['attrs']['spaceBottom']) ? $block['attrs']['spaceBottom'] : 0;
  $mobileSpaceBottom = isset($block['attrs']['mobileSpaceBottom']) ? $block['attrs']['mobileSpaceBottom'] : 0;
  $spaceBottomType = isset($block['attrs']['spaceBottomType']) ? $block['attrs']['spaceBottomType'] : 'em';
  $css = "";
  if ($spaceBottom !== 0) {
      $css .= <<< EOM
  #$id {
    margin-bottom: ${spaceBottom}${spaceBottomType};
  }
EOM;
  }
  if ($mobileSpaceBottom !== 0) {
      $css .= <<< EOM
  @media screen and (max-width: 768px) {
    #$id {
      margin-bottom: ${mobileSpaceBottom}${spaceBottomType};
    }
  }
EOM;
  }
  App::get('css')->register("margin-$id", $css);
}

function sng_custom_css( $block_content, $block ) {
  if (isset($block['attrs']['js']) || isset($block['attrs']['scopedCSS']) || isset($block['attrs']['spaceBottom']) || isset($block['attrs']['mobileSpaceBottom'])) {
    $id = wp_unique_id("sgb-css-id-");
    if (isset($block['attrs']['scopedCSS'])) {
      $css = $block['attrs']['scopedCSS'];
      $css = preg_replace("/id-[a-z0-9]{8}-[a-z0-9]{4}-[a-z0-9]{4}-[a-z0-9]{4}-[a-z0-9]{12}/", $id, $css);
      // プリセットの不具合対応
      $css = preg_replace("/#undefined/", "#".$id, $css);
      App::get('css')->register($id, $css);
    }
    if (isset($block['attrs']['js'])) {
      $js = $block['attrs']['js'];
      App::get('js')->register($id, $js);
    }
    if ((isset($block['attrs']['spaceBottom']) || isset($block['attrs']['mobileSpaceBottom']))) {
      sng_space_css($block, $id);
      // マージンを設定している場合はクラスを付与して返す
      return "<div id=\"$id\" class=\"sgb-space-bottom\">$block_content</div>";
    }
    return "<div id=\"$id\">$block_content</div>";
  }
  return $block_content;
}

add_filter( 'render_block', 'sng_custom_css', 10, 2 );


add_action('wp_footer', function () {
  App::get('js')->print_codes();
}, 9999);
